// File autogenerated

#if !defined(ACCESSPOINTPROXY_H_INCLUDED)
#define ACCESSPOINTPROXY_H_INCLUDED

// TQt includes
#include <tqobject.h>

// TQt D-Bus includes
#include <tqdbuserror.h>

// forward declarations
class TQString;
class TQT_DBusConnection;
class TQT_DBusDataList;
class TQT_DBusError;
class TQT_DBusMessage;
class TQT_DBusProxy;
class TQT_DBusVariant;
template <typename K, typename V> class TQMap;
template <typename T> class TQValueList;

namespace DBus
{

class AccessPointProxy : public TQObject
{
    TQ_OBJECT
    
public:
    AccessPointProxy(const TQString& service, const TQString& path, TQObject* parent = 0, const char* name = 0);

    virtual ~AccessPointProxy();

    void setConnection(const TQT_DBusConnection& connection);

signals:
    void PropertiesChanged(const TQMap< TQString, TQT_DBusVariant >& properties);


public:
    virtual void setDBusProperty(const TQString& name, const TQT_DBusVariant& variant, TQT_DBusError& error);
    virtual TQT_DBusVariant getDBusProperty(const TQString& name, TQT_DBusError& error) const;

    virtual TQ_UINT32 getFlags(TQT_DBusError& error) const;

    virtual TQ_UINT32 getWpaFlags(TQT_DBusError& error) const;

    virtual TQ_UINT32 getRsnFlags(TQT_DBusError& error) const;

    virtual TQValueList< TQ_UINT8 > getSsid(TQT_DBusError& error) const;

    virtual TQ_UINT32 getFrequency(TQT_DBusError& error) const;

    virtual TQString getHwAddress(TQT_DBusError& error) const;

    virtual TQ_UINT32 getMode(TQT_DBusError& error) const;

    virtual TQ_UINT32 getMaxBitrate(TQT_DBusError& error) const;

    virtual TQ_UINT8 getStrength(TQT_DBusError& error) const;

protected slots: // usually no need to reimplement
    virtual void slotHandleDBusSignal(const TQT_DBusMessage& message);

protected:
    TQT_DBusProxy* m_baseProxy;

private: // Hiding copy constructor and assignment operator
    AccessPointProxy(const AccessPointProxy&);
    AccessPointProxy& operator=(const AccessPointProxy&);
}; // class AccessPointProxy

}; // namespace DBus

#endif //ACCESSPOINTPROXY_H_INCLUDED

// End of File

