// File autogenerated

#if !defined(ACTIVECONNECTIONPROXY_H_INCLUDED)
#define ACTIVECONNECTIONPROXY_H_INCLUDED

// TQt includes
#include <tqobject.h>

// TQt D-Bus includes
#include <tqdbuserror.h>

// forward declarations
class TQString;
class TQT_DBusConnection;
class TQT_DBusDataList;
class TQT_DBusError;
class TQT_DBusMessage;
class TQT_DBusObjectPath;
class TQT_DBusProxy;
class TQT_DBusVariant;
template <typename K, typename V> class TQMap;
template <typename T> class TQValueList;

namespace DBus
{

class ActiveConnectionProxy : public TQObject
{
    TQ_OBJECT
    
public:
    ActiveConnectionProxy(const TQString& service, const TQString& path, TQObject* parent = 0, const char* name = 0);

    virtual ~ActiveConnectionProxy();

    void setConnection(const TQT_DBusConnection& connection);

signals:
    void PropertiesChanged(const TQMap< TQString, TQT_DBusVariant >& properties);


public:
    virtual void setDBusProperty(const TQString& name, const TQT_DBusVariant& variant, TQT_DBusError& error);
    virtual TQT_DBusVariant getDBusProperty(const TQString& name, TQT_DBusError& error) const;

    virtual TQT_DBusObjectPath getConnection(TQT_DBusError& error) const;

    virtual TQT_DBusObjectPath getSpecificObject(TQT_DBusError& error) const;

    virtual TQString getUuid(TQT_DBusError& error) const;

    virtual TQValueList< TQT_DBusObjectPath > getDevices(TQT_DBusError& error) const;

    virtual TQ_UINT32 getState(TQT_DBusError& error) const;

    virtual bool getDefault(TQT_DBusError& error) const;

    virtual bool getDefault6(TQT_DBusError& error) const;

    virtual bool getVpn(TQT_DBusError& error) const;

    virtual TQT_DBusObjectPath getMaster(TQT_DBusError& error) const;

protected slots: // usually no need to reimplement
    virtual void slotHandleDBusSignal(const TQT_DBusMessage& message);

protected:
    TQT_DBusProxy* m_baseProxy;

private: // Hiding copy constructor and assignment operator
    ActiveConnectionProxy(const ActiveConnectionProxy&);
    ActiveConnectionProxy& operator=(const ActiveConnectionProxy&);
}; // class ActiveConnectionProxy

}; // namespace DBus

#endif //ACTIVECONNECTIONPROXY_H_INCLUDED

// End of File

