// File autogenerated

#if !defined(BLUETOOTHPROXY_H_INCLUDED)
#define BLUETOOTHPROXY_H_INCLUDED

// TQt includes
#include <tqobject.h>

// TQt D-Bus includes
#include <tqdbuserror.h>

// forward declarations
class TQString;
class TQT_DBusConnection;
class TQT_DBusError;
class TQT_DBusMessage;
class TQT_DBusProxy;
class TQT_DBusVariant;
template <typename K, typename V> class TQMap;

namespace DBus
{

class BluetoothDeviceProxy : public TQObject
{
    TQ_OBJECT
    
public:
    BluetoothDeviceProxy(const TQString& service, const TQString& path, TQObject* parent = 0, const char* name = 0);

    virtual ~BluetoothDeviceProxy();

    void setConnection(const TQT_DBusConnection& connection);

signals:
    void PropertiesChanged(const TQMap< TQString, TQT_DBusVariant >& properties);


public:
    virtual void setDBusProperty(const TQString& name, const TQT_DBusVariant& variant, TQT_DBusError& error);
    virtual TQT_DBusVariant getDBusProperty(const TQString& name, TQT_DBusError& error) const;

    virtual TQString getHwAddress(TQT_DBusError& error) const;

    virtual TQString getName(TQT_DBusError& error) const;

    virtual TQ_UINT32 getBtCapabilities(TQT_DBusError& error) const;

protected slots: // usually no need to reimplement
    virtual void slotHandleDBusSignal(const TQT_DBusMessage& message);

protected:
    TQT_DBusProxy* m_baseProxy;

private: // Hiding copy constructor and assignment operator
    BluetoothDeviceProxy(const BluetoothDeviceProxy&);
    BluetoothDeviceProxy& operator=(const BluetoothDeviceProxy&);
}; // class BluetoothDeviceProxy

}; // namespace DBus

#endif //BLUETOOTHPROXY_H_INCLUDED

// End of File

