// File autogenerated

#if !defined(CONNECTIONSETTINGS_H_INCLUDED)
#define CONNECTIONSETTINGS_H_INCLUDED

// TQt includes
#include <tqmap.h>
#include <tqobject.h>

// TQt D-Bus includes
#include <tqdbuserror.h>

// forward declarations
class TQString;
class TQT_DBusConnection;
class TQT_DBusError;
class TQT_DBusMessage;
class TQT_DBusProxy;
template <typename K> class TQT_DBusDataMap;

namespace DBus
{

class ConnectionSettingsInterface : public TQObject
{
    TQ_OBJECT
    
public:
    ConnectionSettingsInterface(const TQString& service, const TQString& path, TQObject* parent = 0, const char* name = 0);

    virtual ~ConnectionSettingsInterface();

    void setConnection(const TQT_DBusConnection& connection);

signals:
    void AsyncErrorResponseDetected(int asyncCallId, const TQT_DBusError error);

    void Updated();

    void Removed();

    void UpdateAsyncReply(int asyncCallId);

    void DeleteAsyncReply(int asyncCallId);

    void GetSettingsAsyncReply(int asyncCallId, const TQT_DBusDataMap< TQString >& settings);

    void GetSecretsAsyncReply(int asyncCallId, const TQT_DBusDataMap< TQString >& secrets);


public:
    virtual bool UpdateAsync(int& asyncCallId, const TQT_DBusDataMap< TQString >& properties, TQT_DBusError& error);

    virtual bool DeleteAsync(int& asyncCallId, TQT_DBusError& error);

    virtual bool GetSettingsAsync(int& asyncCallId, TQT_DBusError& error);

    virtual bool GetSecretsAsync(int& asyncCallId, const TQString& setting_name, TQT_DBusError& error);

protected slots: // usually no need to reimplement
    virtual void slotHandleDBusSignal(const TQT_DBusMessage& message);

    virtual void slotHandleAsyncReply(int id, const TQT_DBusMessage& message);

protected:
    TQT_DBusProxy* m_baseProxy;

    TQMap<int, TQString> m_asyncCalls;

private: // Hiding copy constructor and assignment operator
    ConnectionSettingsInterface(const ConnectionSettingsInterface&);
    ConnectionSettingsInterface& operator=(const ConnectionSettingsInterface&);
}; // class ConnectionSettingsInterface

}; // namespace DBus

#endif //CONNECTIONSETTINGS_H_INCLUDED

// End of File

