// File autogenerated

#if !defined(MODEMPROXY_H_INCLUDED)
#define MODEMPROXY_H_INCLUDED

// TQt includes
#include <tqobject.h>

// TQt D-Bus includes
#include <tqdbuserror.h>

// forward declarations
class TQString;
class TQT_DBusConnection;
class TQT_DBusError;
class TQT_DBusMessage;
class TQT_DBusProxy;
class TQT_DBusVariant;
template <typename K, typename V> class TQMap;

namespace DBus
{

class ModemDeviceProxy : public TQObject
{
    TQ_OBJECT
    
public:
    ModemDeviceProxy(const TQString& service, const TQString& path, TQObject* parent = 0, const char* name = 0);

    virtual ~ModemDeviceProxy();

    void setConnection(const TQT_DBusConnection& connection);

signals:
    void PropertiesChanged(const TQMap< TQString, TQT_DBusVariant >& properties);


public:
    virtual void setDBusProperty(const TQString& name, const TQT_DBusVariant& variant, TQT_DBusError& error);
    virtual TQT_DBusVariant getDBusProperty(const TQString& name, TQT_DBusError& error) const;

    virtual TQ_UINT32 getModemCapabilities(TQT_DBusError& error) const;

    virtual TQ_UINT32 getCurrentCapabilities(TQT_DBusError& error) const;

protected slots: // usually no need to reimplement
    virtual void slotHandleDBusSignal(const TQT_DBusMessage& message);

protected:
    TQT_DBusProxy* m_baseProxy;

private: // Hiding copy constructor and assignment operator
    ModemDeviceProxy(const ModemDeviceProxy&);
    ModemDeviceProxy& operator=(const ModemDeviceProxy&);
}; // class ModemDeviceProxy

}; // namespace DBus

#endif //MODEMPROXY_H_INCLUDED

// End of File

