// File autogenerated

#if !defined(VPNPLUGINPROXY_H_INCLUDED)
#define VPNPLUGINPROXY_H_INCLUDED

// TQt includes
#include <tqobject.h>

// TQt D-Bus includes
#include <tqdbuserror.h>

// forward declarations
class TQString;
class TQT_DBusConnection;
class TQT_DBusError;
class TQT_DBusMessage;
class TQT_DBusProxy;
class TQT_DBusVariant;
template <typename K, typename V> class TQMap;
template <typename K> class TQT_DBusDataMap;

namespace DBus
{

class VPNPluginProxy : public TQObject
{
    TQ_OBJECT
    
public:
    VPNPluginProxy(const TQString& service, const TQString& path, TQObject* parent = 0, const char* name = 0);

    virtual ~VPNPluginProxy();

    void setConnection(const TQT_DBusConnection& connection);

signals:
    void StateChanged(TQ_UINT32 state);

    void Config(const TQMap< TQString, TQT_DBusVariant >& config);

    void Ip4Config(const TQMap< TQString, TQT_DBusVariant >& ip4config);

    void Ip6Config(const TQMap< TQString, TQT_DBusVariant >& ip6config);

    void LoginBanner(const TQString& banner);

    void Failure(TQ_UINT32 reason);


public:
    virtual bool Connect(const TQT_DBusDataMap< TQString >& connection, TQT_DBusError& error);

    virtual bool NeedSecrets(const TQT_DBusDataMap< TQString >& settings, TQString& setting_name, TQT_DBusError& error);

    virtual bool Disconnect(TQT_DBusError& error);

    virtual bool SetConfig(const TQMap< TQString, TQT_DBusVariant >& config, TQT_DBusError& error);

    virtual bool SetIp4Config(const TQMap< TQString, TQT_DBusVariant >& config, TQT_DBusError& error);

    virtual bool SetIp6Config(const TQMap< TQString, TQT_DBusVariant >& config, TQT_DBusError& error);

    virtual bool SetFailure(const TQString& reason, TQT_DBusError& error);

public:
    virtual void setDBusProperty(const TQString& name, const TQT_DBusVariant& variant, TQT_DBusError& error);
    virtual TQT_DBusVariant getDBusProperty(const TQString& name, TQT_DBusError& error) const;

    virtual TQ_UINT32 getState(TQT_DBusError& error) const;

protected slots: // usually no need to reimplement
    virtual void slotHandleDBusSignal(const TQT_DBusMessage& message);

protected:
    TQT_DBusProxy* m_baseProxy;

private: // Hiding copy constructor and assignment operator
    VPNPluginProxy(const VPNPluginProxy&);
    VPNPluginProxy& operator=(const VPNPluginProxy&);
}; // class VPNPluginProxy

}; // namespace DBus

#endif //VPNPLUGINPROXY_H_INCLUDED

// End of File

