// File autogenerated

#if !defined(WIMAXPROXY_H_INCLUDED)
#define WIMAXPROXY_H_INCLUDED

// TQt includes
#include <tqobject.h>

// TQt D-Bus includes
#include <tqdbuserror.h>

// forward declarations
class TQString;
class TQT_DBusConnection;
class TQT_DBusDataList;
class TQT_DBusError;
class TQT_DBusMessage;
class TQT_DBusObjectPath;
class TQT_DBusProxy;
class TQT_DBusVariant;
template <typename K, typename V> class TQMap;
template <typename T> class TQValueList;

namespace DBus
{

class WiMaxDeviceProxy : public TQObject
{
    TQ_OBJECT
    
public:
    WiMaxDeviceProxy(const TQString& service, const TQString& path, TQObject* parent = 0, const char* name = 0);

    virtual ~WiMaxDeviceProxy();

    void setConnection(const TQT_DBusConnection& connection);

signals:
    void PropertiesChanged(const TQMap< TQString, TQT_DBusVariant >& properties);

    void NspAdded(const TQT_DBusObjectPath& nsp);

    void NspRemoved(const TQT_DBusObjectPath& nsp);


public:
    virtual bool GetNspList(TQValueList< TQT_DBusObjectPath >& nsps, TQT_DBusError& error);

public:
    virtual void setDBusProperty(const TQString& name, const TQT_DBusVariant& variant, TQT_DBusError& error);
    virtual TQT_DBusVariant getDBusProperty(const TQString& name, TQT_DBusError& error) const;

    virtual TQString getHwAddress(TQT_DBusError& error) const;

    virtual TQ_UINT32 getCenterFrequency(TQT_DBusError& error) const;

    virtual TQ_INT32 getRssi(TQT_DBusError& error) const;

    virtual TQ_INT32 getCinr(TQT_DBusError& error) const;

    virtual TQ_INT32 getTxPower(TQT_DBusError& error) const;

    virtual TQString getBsid(TQT_DBusError& error) const;

    virtual TQT_DBusObjectPath getActiveNsp(TQT_DBusError& error) const;

protected slots: // usually no need to reimplement
    virtual void slotHandleDBusSignal(const TQT_DBusMessage& message);

protected:
    TQT_DBusProxy* m_baseProxy;

private: // Hiding copy constructor and assignment operator
    WiMaxDeviceProxy(const WiMaxDeviceProxy&);
    WiMaxDeviceProxy& operator=(const WiMaxDeviceProxy&);
}; // class WiMaxDeviceProxy

}; // namespace DBus

#endif //WIMAXPROXY_H_INCLUDED

// End of File

